/*	
	common functions
*/

var TOUCHABLE:Boolean	= true;

var movie:Object	= {
	makeNew : function(mcName : String, mc : MovieClip)	{
		trace("movie.makeNew(mcName = " + mcName + ", mc = " + targetPath(mc) + ")");
		if (mc == undefined)	mc	= _root;
		
		delete mc[mcName].onEnterFrame;
		removeMovieClip(mc[mcName]);
		
		mc.createEmptyMovieClip(mcName, mc.getNextHighestDepth());
		mc[mcName]._frm	= 0;
	},
	
	
	zoomTo : function(mc : MovieClip, dest : Number, destAlpha : Number, func : Function)	{
		TOUCHABLE	= false;
		mc._frm		= 0;
		
		mc.onEnterFrame	= function(Void) : Void	{
			if (mc._frm < 8)	{
				mc._alpha	+= (destAlpha - mc._alpha) * 0.4;
				mc._xscale	+= (dest - mc._xscale) * 0.5;
				mc._yscale	= mc._xscale;
			} else {
				delete mc.onEnterFrame;
				
				mc._xscale 	= dest;
				mc._yscale 	= dest;
				mc._alpha	= destAlpha;
				TOUCHABLE	= true;
				
				if (func != undefined)	func();
			}	//	end
	
			mc._frm++;	
		}	//	end
		
	},
	
	
	slideToX : function(mc : MovieClip, dest : Number, func : Function)	{
		TOUCHABLE	= false;
		mc._frm		= 0;
		mc._frmMax	= (mc._x > dest) ? 8 : 7;
		
		mc.onEnterFrame	= function(Void) : Void	{
			if (mc._frm < mc._frmMax)	{
				mc._x	+= (dest - mc._x) * 0.5;
			} else {
				delete mc.onEnterFrame;
				delete mc._frm;
				delete mc._frmMax;
				
				mc._x		= dest;
				TOUCHABLE	= true;
				
				if (func != undefined)	func();
			}	//	end
	
			mc._frm++;	
		}	//	end
	
	},
	
	
	slideToY : function(mc : MovieClip, dest : Number, func : Function)	{
		TOUCHABLE	= false;
		mc._frm		= 0;
		mc._frmMax	= (mc._y > dest) ? 8 : 7;
		
		mc.onEnterFrame	= function(Void) : Void	{
			if (mc._frm < mc._frmMax)	{
				mc._y	+= (dest - mc._y) * 0.5;
			} else {
				delete mc.onEnterFrame;
				delete mc._frm;
				delete mc._frmMax;
				
				mc._y		= dest;
				TOUCHABLE	= true;
				
				if (func != undefined)	func();
			}	//	end
			
			mc._frm++;	
		}	//	end
	
	}, 
	
	
	slideTo : function(mc : MovieClip, destX : Number, destY : Number, func : Function)	{
		TOUCHABLE	= false;
		mc._frm		= 0;
		
		mc.onEnterFrame	= function(Void) : Void	{
			if (mc._frm < 9)	{
				mc._x	+= (destX - mc._x) * 0.5;
				mc._y	+= (destY - mc._y) * 0.5;
			} else {
				delete mc.onEnterFrame;
				delete mc._frm;
				
				mc._x		= destX;
				mc._y		= destY;
				TOUCHABLE	= true;
				
				if (func != undefined)	func();
			}	//	end
	
			mc._frm++;	
		}	//	end
	
	},

	
	remove : function(mc : MovieClip)	{
		delete mc.onEnterFrame;
		delete mc._frm;
		removeMovieClip(mc);
	}

}


var events:Object	= {
	init : function(Void)	{
		events._alphaNormal	= 30;
		events._alphaPress	= 100;
	},
	
	
	dispatch : function(mc : MovieClip, func : Function)	{
		mc.onPress	= function(Void) : Void	{
			if (!TOUCHABLE)	return;
			
			this.gotoAndStop(2);
		
			this.onMouseUp	= function(Void) : Void	{
				this.gotoAndStop(1);
				delete this.onMouseUp;
			}	//	end
			
			this.onDragOut	= function(Void) : Void	{
				this.gotoAndStop(1);
			}	//	end
			
		
		}	//	end
		
		mc.onRelease	= function(Void) : Void	{
			if (!TOUCHABLE)	return;
			
			this.gotoAndStop(1);
			func();
		}	//	end
	
	},
	
	
	dispatchRepeat : function(mc : MovieClip, funcLong : Function, funcShort : Function)	{
		mc._step	= 0;
		mc._first	= 0;
		mc._timer	= 0;
		
		mc.onPress	= function(Void) : Void	{
			if (!TOUCHABLE)	return;
		
			this.gotoAndStop(2);
			
			this._step	= 0;
			this._first	= getTimer();
			this._timer	= getTimer();
			
			this.onEnterFrame	= function(Void) : Void	{
				if (getTimer() - this._timer > 250)	{
					if (this._step == 0)	{
						this._step	= 1;
						this._timer	= getTimer();
					} else {
						funcLong();
						this._timer	= getTimer();
					}	//	end
				
				}	//	end
			
			}	//	end
		
			this.onMouseUp	= function(Void) : Void	{
				delete this.onEnterFrame;
				delete this.onMouseUp;
				
				this.gotoAndStop(1);
				this._step	= 0;
			}	//	end
		
			this.onDragOut	= function(Void) : Void	{
				delete this.onEnterFrame;
			
				this.gotoAndStop(1);
				this._step	= 0;
			}	//	end
		
		}	//	end
		
		mc.onRelease	= function(Void) : Void	{
			if (!TOUCHABLE)	return;
			
			delete this.onEnterFrame;
			delete this.onMouseUp;
			
			this.gotoAndStop(1);
			this._step	= 0;
			
			if (getTimer() - this._first < 300)	funcShort();
		}	//	end

	},	


	dispatchAlpha : function(mc : MovieClip, func : Function)	{
		mc.onPress	= function(Void) : Void	{
			if (!TOUCHABLE)	return;
			
			this._alpha	= 40;
			
			this.onMouseUp	= function(Void) : Void	{
				this._alpha	= 100;
				delete this.onMouseUp;
			}	//	end
			
			this.onDragOut	= function(Void) : Void	{
				this._alpha	= 100;
			}	//	end
		
		}	//	end
		
		mc.onRelease	= function(Void) : Void	{
			if (!TOUCHABLE)	return;
			
			this._alpha	= 100;
			func();
		}	//	end
		
	},	
	
	
	remove : function(mc : MovieClip)	{
		delete mc.onPress;
		delete mc.onRelease;
		delete mc.onEnterFrame;
	}

}


function displayNumber(mc : MovieClip, value : Number) : Void	{
	mc.mcNumber1.gotoAndStop(value % 10 + 1);
	mc.mcNumber2.gotoAndStop(int(value / 10) + 1);
}


function rnd(min_value : Number, max_value : Number) : Number {
	return Number(Math.floor(Math.random() * (max_value - min_value + 1)) + min_value);
}	// end 


function doNext(idx : Number, func : Function) : Void	{
	movie.makeNew("movNext" + idx);

	_root["movNext" + idx]._delayCount	= 0;
	_root["movNext" + idx].onEnterFrame	= function(Void) : Void	{
		if (this._delayCount == 1)	{
			func();
			delete this._delayCount;
			movie.remove(_root["movNext" + idx]);
		}	//	end
		
		this._delayCount++;
	}	//	end	

}


function changeTxtFormat(mc : MovieClip, txtColor : Number, txtBold : Boolean, txtAlign : String) : Void	{
	var txtFormat:TextFormat	= new TextFormat();

	txtFormat.color	= txtColor;
	txtFormat.bold	= txtBold;
	txtFormat.align	= txtAlign;

	mc.setTextFormat(txtFormat);
	delete txtFormat;
}



/*
	init
*/

events.init();