/*
	loader
*/

var loader:Object	= {
	init : function(Void)	{
		trace("loader.init()");
		coverListener.onLoadInit	= function(mc : MovieClip) : Void	{
			var imgWidth:Number		= 0;
			var imgHeight:Number	= 0;
			var widthRate:Number	= 0;
			var heightRate:Number	= 0;
			
			coverLoader.removeListener(coverListener);
			coverDefault	= false;
			mcMask._alpha	= 100;
			
			mc._xscale	= 100;
			mc._yscale	= 100;
			imgWidth	= mc._width;
			imgHeight	= mc._height;
			widthRate	= mc._width  / DISPLAY_WIDTH;
			heightRate	= mc._height / DISPLAY_HEIGHT;
			
			if (imgWidth != DISPLAY_WIDTH || imgHeight != DISPLAY_HEIGHT)	{
				if (widthRate < heightRate)	{
					mc._width	= DISPLAY_WIDTH;
					mc._height	= int(imgHeight * (DISPLAY_WIDTH / imgWidth));
				}
				else	{
					mc._width	= int(imgWidth * (DISPLAY_HEIGHT / imgHeight));
					mc._height	= DISPLAY_HEIGHT;
				}
			}
			//	end			
			
			mc._x	= DISPLAY_WIDTH_HALF  - int(mc._width  / 2);
			mc._y	= DISPLAY_HEIGHT_HALF - int(mc._height / 2);

			trace("coverListener.onLoadInit(mc = " + targetPath(mc) + ")" + "\n\tmc._x = " + mc._x + "\n\tmc._y = " + mc._y + "\n\tmc._width = " + mc._width + "\n\tmc._height = " + mc._height);
			
			if (!musicFirst)	loader.changeTo();
			else				loader.firstScene();
			
			delete imgWidth;
			delete imgHeight;
		}	//	end
	
		coverListener.onLoadError	= function(mc : MovieClip) : Void	{
			trace("coverListener.onLoadError(mc = " + targetPath(mc) + ")");
			coverLoader.removeListener(coverListener);
			coverDefault	= true;
			mcMask._alpha	= 0;
			
			coverNum++;
			if (coverNum > 8)	coverNum	= 1;
			
			movie.remove(mc);
			_root["mcCover" + musicFlag].attachMovie("linkCover", "mcImg", _root["mcCover" + musicFlag].getNextHighestDepth());
			_root["mcCover" + musicFlag].mcImg.gotoAndStop(coverNum);
			
			if (!musicFirst)	loader.changeTo();
			else				loader.firstScene();
		}	//	end
	
	},
	
	
	updates : function(Void)	{
		var imgFileName:String;
		
		musicIdx	= player.getIdx();
		musicTotal	= player.getTotalFile();

		trace("loader.updates()" + "\n\tmusicTotal = " + musicTotal + "\n\tmusicIdx = " + musicIdx + "\n\tmusicPrevIdx = " + musicPrevIdx);
		
		if (musicFirst)	loader.firstScene();
		
		if (musicTotal > 0)	{
			if (musicIdx != musicPrevIdx)	{
				ext_fscommand2("GetEtcFileName", musicIdx, "musicPath");
				
				trace("loader.updates()" + "\n\tmusicPath = " + musicPath + "\n\tmusicPrevPath = " + musicPrevPath);
				
				if (musicPath != musicPrevPath)	{
					musicPrevIdx	= musicIdx;
					musicPrevPath	= "";
					musicFlag		= (musicFlag == 1) ? 2 : 1;
			
					loader.displayTitle();
					seeks.displayElapsed();
					seeks.displayTotal();
					
					//	check lyrics
					if (optionLyrics)	lyrics.check();
					else	lyrics.remove(); 

					//	load albumart
					coverLoader.addListener(coverListener);
					movie.makeNew("mcImg", _root["mcCover" + musicFlag]);
					
					if (optionCover)	imgFileName = musicIdx + ".MU0";
					else	imgFileName = "NOART.MU0";
					
					// TEST
					//imgFileName = (musicFlag == 1)? "./img/0.ab0":"./img/1.ab0";
					
					trace("loader.updates()" + "\n\timgFileName = " + imgFileName + "\n\tmcCover" + musicFlag + " = " + targetPath(_root["mcCover" + musicFlag]) + "\n\tmcImg = " + targetPath(_root["mcCover" + musicFlag].mcImg));
					
					coverLoader.loadClip(imgFileName, _root["mcCover" + musicFlag].mcImg);
				}	//	end
				
			}	//	end
		
		} else {
			//if (musicFirst)	loader.firstScene();
		}	//	end
		
	},
	
	
	displayTitle : function(Void)	{
		with (mcCon["mcTitle" + musicFlag])	{
			txTitle.hscroll	= 0;
			txTitle.text	= player.getTitle(musicIdx, true);
			txArtist.text	= player.getArtist(musicIdx, true);
			txInfo.text		= player.getSampleRate() + " / " + player.getBitRate() + " / " + player.getCodec();
		}	//	end
		
		changeTxtFormat(mcCon["mcTitle" + musicFlag].txTitle, 0xFFFFFF, true, "center");
		changeTxtFormat(mcCon["mcTitle" + musicFlag].txArtist, 0xFFFFFF, true, "center");
		changeTxtFormat(mcCon["mcTitle" + musicFlag].txInfo, 0xAAAAAA, true, "center");
	},
	
	
	displayInfo : function(Void)	{
	},
	
	
	firstScene : function(Void)	{
		trace("loader.firstScene()");
		musicFirst	= false;
		
		loader.prepareTo();
		loader.setTo();
		doNext(100, music.begin);
	},
	
	
	changeTo : function(Void)	{
		trace("loader.changeTo()");
		TOUCHABLE	= false;
	
		loader.prepareTo();
		
		movie.makeNew("movAlpha");
		movAlpha._frmMax		= (musicDir == SLIDE_LEFT) ? 8 : 7;
		movAlpha.onEnterFrame	= function(Void) : Void	{
			if (this._frm < this._frmMax)	{
				mcCon.mcTitle1._x	+= (coverDest1 - mcCon.mcTitle1._x) * 0.5;
				mcCon.mcTitle2._x	+= (coverDest2 - mcCon.mcTitle2._x) * 0.5;
				mcCover1._alpha		+= coverFade1;
				mcCover2._alpha		+= coverFade2;
			} else {
				delete this._frmMax;
				movie.remove(movAlpha);
				
				loader.setTo();
				
				//	get title length
				music.getTitleLength();
				
				//	clear
				loader.clearDummy();
				
				musicDir	= SLIDE_LEFT;
				TOUCHABLE	= true;
			}	//	end
		
			this._frm++;
		}	//	end
	
	},
	
	
	clearDummy : function(Void)	{
		if (musicFlag == 1)	{
			coverLoader.unloadClip(mcCover2.mcImg);
			movie.remove(mcCover2.mcImg);
		} else {
			coverLoader.unloadClip(mcCover1.mcImg);
			movie.remove(mcCover1.mcImg);
		}	//	end
		
	},
	
	
	prepareTo : function(Void)	{
		if (musicFlag == 1)	{
			mcCon.mcTitle1._x	= (musicDir == SLIDE_LEFT) ? (DISPLAY_WIDTH + 20) : -(DISPLAY_WIDTH) + 20;
			mcCon.mcTitle2._x	= 20;
			mcCover1._alpha		= 0;
			mcCover2._alpha		= 100;
			coverAlpha1			= 100;
			coverAlpha2			= 0;
			coverFade1			= (musicDir == SLIDE_LEFT) ? 12 : 13;
			coverFade2			= (musicDir == SLIDE_LEFT) ? -12 : -13;
		} else {
			mcCon.mcTitle1._x	= 20;
			mcCon.mcTitle2._x	= (musicDir == SLIDE_LEFT) ? (DISPLAY_WIDTH + 20) : -(DISPLAY_WIDTH) + 20;
			mcCover1._alpha		= 100;
			mcCover2._alpha		= 0;
			coverAlpha1			= 0;
			coverAlpha2			= 100;
			coverFade1			= (musicDir == SLIDE_LEFT) ? -12 : -13;
			coverFade2			= (musicDir == SLIDE_LEFT) ? 12 : 13;
		}	//	end

		if (musicDir == SLIDE_LEFT)	{
			coverDest1		= mcCon.mcTitle1._x - DISPLAY_WIDTH;
			coverDest2		= mcCon.mcTitle2._x - DISPLAY_WIDTH;
		} else {
			coverDest1		= mcCon.mcTitle1._x + DISPLAY_WIDTH;
			coverDest2		= mcCon.mcTitle2._x + DISPLAY_WIDTH;
		}	//	end

	},
	
	
	setTo : function(Void)	{
		mcCon.mcTitle1._x	= coverDest1;
		mcCon.mcTitle2._x	= coverDest2;
		mcCover1._alpha		= coverAlpha1;
		mcCover2._alpha		= coverAlpha2;
	}


}