/*
	player engine
*/

var player:Object	= {
	getState : function(Void)	{
		//	1 : play
		//	2 : pause
		//	3 : stop
		return ext_fscommand2("GetEtcState");
	},
	
	
	getVol : function(Void)	{
		return ext_fscommand2("GetEtcVolume");
	},
	
	
	getIdx : function(Void)	{
		return ext_fscommand2("GetEtcCurPLIndex");
	},
	
	
	getTitle : function(idx : Number, flag : Boolean)	{
		var returnValue:Number	= ext_fscommand2("GetAudTitle", idx, "musicTitle");
		
		if (returnValue == -1)	{
			ext_fscommand2("GetEtcFileName", idx, "musicFile");
			
			if (flag)	return musicFile.toUpperCase();
			else		return musicFile;
		} else {
			if (flag)	return musicTitle.toUpperCase();
			else		return musicTitle;
		}	//	end
		
		delete returnValue;
	},
	
	
	getArtist : function(idx : Number, flag : Boolean)	{
		ext_fscommand2("GetAudArtist", idx, "musicArtist");
		
		if (flag)	return musicArtist.toUpperCase();
		else		return musicArtist;
	},
	
	
	getCurrent : function(Void)	{
		//return ext_fscommand2("GetAudPlayTimeOriginal");
		return ext_fscommand2("GetAudPlayTime");
	},	
	
	
	getElapsed : function(Void)	{
		return ext_fscommand2("GetAudPlayTime");
	},
	
	
	getTotal : function(Void)	{
		return ext_fscommand2("GetAudTotalTime");
	},	
	
	
	getHour : function(value : Number)	{
		var returnValue:String	= "0" + int(value / 3600);
		
		return returnValue.substr(-2, 2);
		delete returnValue;
	},
	
	
	getMin : function(value : Number)	{
		var returnValue:String	= "0" + int(value % 3600 / 60);
		
		return returnValue.substr(-2, 2);
		delete returnValue;
	},
	

	getSec : function(value : Number)	{
		var returnValue:String	= "0" + int(value % 3600 % 60);
		
		return returnValue.substr(-2, 2);
		delete returnValue;
	},	
	
	
	getTotalFile : function(Void)	{
		return ext_fscommand2("GetEtcTotalPLNum");
	},
	
	
	getCountNumber : function(value : Number) {
		var returnValue:String	= "000000" + value;
		
		return returnValue.substr(-6, 6);
		delete returnValue;
	},
	
	
	getTimeDisplay : function(Void)	{
		return ext_fscommand2("GetDisPlayTime");
	},
	
	
	getSkip : function(Void)	{
		return ext_fscommand2("GetAudSkipLength");
	},
	
	
	getSeek : function(Void)	{
		return ext_fscommand2("GetAudScanSpeed");
	},
	
	
	getResume : function(Void)	{
		return ext_fscommand2("GetAudResume");
	},
	
	
	getRemove : function(Void)	{
		return ext_fscommand2("GetSilenceDelete");
	},
	
	
	getLyrics : function(Void)	{
		return ext_fscommand2("GetDisLyrics");
	},
	
	
	getRepeat : function(Void)	{
		return ext_fscommand2("GetAudRepeat");
	},
	
	
	getShuffle : function(Void)	{
		return ext_fscommand2("GetAudShuffle");
	},
	
	
	getBoundary : function(Void)	{
		return ext_fscommand2("GetAudBoundary");
	},
	
	
	getBit : function(Void)	{
		return ext_fscommand2("GetAudBitPerSample");
	},	
	
		
	getBitRate : function(Void)	{
		var value:Number	= ext_fscommand2("GetAudBitRate");
		
		if (value <= 0)	return "SCANNING";
		else	return value + " kbps";
		
		delete value;
	},
	
	
	getSampleRate : function(Void)	{
		var value:Number = ext_fscommand2("GetAudSampleRate");
		
		if (value <= 0)	return "SCANNING";
		else	return value + " kHz";
		
		delete value;
	},
	
	
	getCodec : function(Void)	{
		ext_fscommand2("GetAudCodec", "txCodec");
		
		if (txCodec == "NONE")	return "SCANNING";
		else	return txCodec;
	},
	
	
	getJE : function(Void)	{
		return ext_fscommand2("GetJetEffectIndex");
	},
	

	getABRepeat : function(Void)	{
		return ext_fscommand2("GetAudABMode");
	},
	
	
	getABStart : function(Void)	{
		return ext_fscommand2("GetAudABModeStartTime");
	},
	

	getABEnd : function(Void)	{
		return ext_fscommand2("GetAudABModeEndTime");
	},	
	

	getLyricsType : function(Void)	{
		return ext_fscommand2("GetAudLDBType");
	},


	getLevelMeter : function(Void)	{
		return ext_fscommand2("GetAudLevelmeterType");
	},
	
	
	/*
		music control
	*/
	
	
	musicPlay : function(Void)	{
		ext_fscommand2("KeyAudPlay");
	},
	

	musicPause : function(Void)	{
		ext_fscommand2("KeyAudPause");
	},
	
	
	musicRew : function(flag : Number)	{
		if (!TOUCHABLE)	return;
		
		ext_fscommand2("KeyAudLongREW", flag);
		extEvent(_global.KEY_DISPLAY_UPDATE);
	},	


	musicFF : function(flag : Number)	{
		if (!TOUCHABLE)	return;
		
		ext_fscommand2("KeyAudLongFF", flag);
		extEvent(_global.KEY_DISPLAY_UPDATE);
	},
	
	
	musicPrev : function(Void)	{
		ext_fscommand2("KeyAudShortREW");
		extEvent(_global.KEY_DISPLAY_UPDATE);
	},
	
	
	musicNext : function(Void)	{
		ext_fscommand2("KeyAudShortFF");
		extEvent(_global.KEY_DISPLAY_UPDATE);
	},
	
	
	checkDRM : function(Void)	{
		if (player.getTotalFile() >= 0)	{
			if (ext_fscommand2("GetEtcOpenState", "txError") == 0)	{
				//	success
			} else {
				//	error
				popup.init(txError);
			}	//	end
			
		}	//	end
		
	},
	
	
	/*	
		set value to player
	*/

	setTimeDisplay : function(value : Number)	{
		ext_fscommand2("SetDisPlayTime", value);
	},
	
	
	setSeek : function(value : Number)	{
		ext_fscommand2("SetAudScanSpeed", value);
	},
	
	
	setRemove : function(value : Number)	{
		ext_fscommand2("SetSilenceDelete", value);
	},
	
	
	setLyrics : function(value : Number)	{
		ext_fscommand2("SetDisLyrics", value);
	},
	
	
	setRepeat : function(value : Number)	{
		ext_fscommand2("SetAudRepeat", value);
	},
	
	
	setShuffle : function(value : Number)	{
		ext_fscommand2("SetAudShuffle", value);
	},
	
	
	setBoundary : function(value : Number)	{
		ext_fscommand2("SetAudBoundary", value);
	},

	
	setJE : function(idx : Number)	{
		ext_fscommand2("SetJetEffectIndex", idx);
	}


}